				LIST P=P16F877A
	 			include "P16F877A.INC"
				include	<exsegment.h>
				
				GLOBAL	SEGWRITE
	;			UDATA	
;SEGWRITE		RES		1
				
				CODE

SEGWRITE:
				MOVLW	0x1
				CALL	X_DELAY
				BCF		STATUS,0
				BCF		STATUS,2
				RRF		SELECTBIT,1
				INCF	DIGITCOUNTER,1
			; 	
				MOVLW	0x01
				SUBWF	SELECTBIT,0
				BTFSC	STATUS,0
				GOTO	THERE
				MOVLW	0x08
				MOVWF	SELECTBIT
				CLRF	DIGITCOUNTER
				CLRF	INDEX
THERE:			
				MOVF	DIGITCOUNTER,0
				ANDLW	0x01
				MOVWF	TEMP1
				MOVF	TEMP1,1
				BTFSS	STATUS,2
				GOTO	THERE1
				MOVF	INDEX,0
				ADDLW	0x2D
				MOVWF	FSR
				MOVF	INDF,0
				ANDWF	MASKBIT0,0 ;0X0F
				MOVWF	TEMP1
				GOTO	THERE2
THERE1:
				MOVF	INDEX,0
				ADDLW	0x2D
				MOVWF	FSR
				MOVF	INDF,0
				ANDWF	MASKBIT1,0 ;0XF0
				MOVWF	TEMP1
				SWAPF	TEMP1,1
				INCF	INDEX
THERE2:
				MOVF	PORTC,0
				ANDLW	0xF0
				
			;	IORLW	0x0F
			;	MOVWF	TEMP2
			;	COMF	SELECTBIT,0
				
				IORWF	SELECTBIT,0
			;	ANDWF	TEMP2,1
				
			;	MOVF	TEMP2,0
				MOVWF	PORTC
	
				MOVF	TEMP1,0
				CALL	LCDCODE
				MOVWF	PORTB

			
				DECFSZ	COUNT
				GOTO	SEGWRITE

				RETURN

LCDCODE:
				ADDWF	PCL,1
				RETLW   0x3F
				RETLW	0x30;0x06
				RETLW	0x5B
				RETLW	0x4F
				RETLW	0x66
				RETLW	0x6D
				RETLW	0x7D  
				RETLW	0x07
				RETLW	0x7F
				RETLW	0x67
				
				

X_DELAY:	
			;	MOVLW		D'10'
    			MOVWF       D_VALUE             ; +1        1 cycle
X_DELAY_LOOP:
    			CALL        X_DELAY1            ; step1     wait 500uSec
    			DECFSZ      D_VALUE, F          ; step2     1 cycle
    			GOTO        X_DELAY_LOOP     ; step3     2 cycles
				RETURN     
    			
X_DELAY1:
    			MOVLW       D'249'              ; +1        1 cycle
    			MOVWF       D_VALUE1               ; +2        1 cycle1
X_DELAY1_LOOP
    			DECFSZ      D_VALUE1, F            ; step1     1 cycle
    			GOTO        X_DELAY1_LOOP       ; step2     2 cycles
				RETURN 
				 
				END
