
  ; THIS PROGRAM BLINKS LED IN DEMO BOARD FOR 0.5 SEC IN PORT A,0
  ; JUST DOWNLOAD HEX FILE AND TEST IT WITH EASILY using DEMO BOARD





	LIST p=16F877,r=DEC	; Put assembler into PIC16f877 mode.
				; r=DEC means decimal numbers are
				; assumed if 'B' or 'h' not specified.

	include "P16F877.INC"


;**************Declare Variables************************

	x		equ	32
	y		equ	33
	z		equ	34

;**************Initialise interrupt subroutine**********

	goto 5
	ORG 4
	goto interrupt
	ORG 5

;**************Initialise Ports*************************

	
	
	CLRF PORTA		; INTIALISE PORTA = OUTPUT
	MOVLW B'00000000'
	TRIS PORTA
	BSF STATUS, RP0 
	MOVLW 0x06 
	MOVWF ADCON1 		; INTIALISE PORTA= DIGITAL OUTPUT
	BCF STATUS, RP0



;**************Start Of Main Program********************

Start		;Flashes the  LED connected to Port A,0	
		
	BSF	PORTA,0			;PORTA Bit ON
	call	delay			;CALL DELAY SUBROUTINE
	BCF	PORTA,0			;PORTA BIT OFF
	call	delay
	goto	Start

	goto	$			;Safety Caching Loop

;**************Subroutines******************************


interrupt
	retfie				;Interrupt


delay
	movlw	240			;w  =  240
	movwf	z			;z  =  w
Loop
	incfsz	x,f			;x  =  x +1 , Skip Next If Zero
	goto	Loop
	incfsz	y,f			;y  =  y +1 , Skip Next If Zero
	goto	Loop
	return				;Return


	End

